
{% extends 'base.html' %}

{% block title %}
    List
{% endblock title %}

{% block content %}
    <h1>Employee List</h1>
    
    <!-- <a href="{% url 'employee_create' %}" class="btn btn-primary">Create</a> -->

    <form method="post" id="form1" novalidate>
        {% csrf_token %}
        <div class="mb-3">
            <label for="name" class="form-label">Name</label>
            <input type="text" class="form-control" id="name"  name="name" >  
            <div id="nameError" class="form-text" style="display:none;color:red;"></div>
        </div>
        <div class="mb-3">
            <label for="age" class="form-label">Age</label>
            <input type="text" class="form-control" id="age"  name="age"  > 
            <div id="ageError" class="form-text" style="display:none;color:red;"></div>
        </div>
        <div class="mb-3"> 
            <input type="submit" class="btn btn-success"> 
        </div>
    </form>
        
    <table class="table">
        <thead>
            <th>Name</th> 
            <th>Age</th> 
        </thead>

        <tbody id="tbody-id">
            {% for emp in employees %}
                <tr>
                    <td>{{emp.name}}</a></td> 
                    <td>{{emp.age}}</td> 
                </tr>
            {% endfor %}
        </tbody>
    </table>

    <script>

        let form1 = document.forms[0];
        // let form1 = document.getElementById("form1");

        form1.addEventListener('submit', (e) => {
            e.preventDefault();
            let formData = new FormData(form1); // e.target also works
 
            // for(var pair of formData.entries()) {
            //     console.log(pair[0]+ ', '+ pair[1]);
            // }

            fetch("{% url 'employee_create' %}", { 
                method: 'post',
                body: formData, 
                headers: {
                    'X-CSRFToken': formData.get('csrfmiddlewaretoken')
                },
            }).then(response => {
                // return response.text();
                return response.json();
            }).then(data =>{
                console.log(data);
                // document.getElementById('tbody-id').innerHTML += data;
                // form1.reset();
                 
                
                if(data['errors']){
                    for(let err of data['errors']){
                        // console.log(err[0], err[1]);
                        let el = document.getElementById(err[0]+'Error');
                        el.innerText = err[1];
                        el.style.display = 'block';

                        setTimeout(() => {
                            el.style.display = 'none'
                        }, 2000);
                    }
                }else{
                    let instance = JSON.parse(data['instance']);
                    // console.log(typeof instance);
                    // console.log(instance[0].fields['name'])
                    // console.log(instance[0].fields['age']) 

                    let r = `
                    <tr>
                        <td>${instance[0].fields['name']}</td> 
                        <td>${instance[0].fields['age']}</td> 
                    </tr>
                        `;
                    document.getElementById('tbody-id').innerHTML += r;
                    form1.reset();
                }
            
            });
            
        })

    </script>

{% endblock content %}